using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;

namespace NoJava2Lib.GUI.OnForms
{
    abstract class ChildScreen : GUIObject, IChildScreen, IParentScreen
    {
        /// <summary>
        /// g/k
        /// </summary>
        PointF zoom;
        /// <summary>
        /// 
        /// </summary>
        float opacity;
        /// <summary>
        /// }EXL
        /// </summary>
        bool IsMouseEnable;
        PointF location;
        /// <summary>
        /// ꏊ
        /// </summary>
        public PointF Location { get { return location; } }
        SizeF size;
        /// <summary>
        /// 傫
        /// </summary>
        public SizeF Size { get { return size; } }
        /// <summary>
        /// `ȂȂȂƂ
        /// </summary>
        protected RectangleF[] needtoDrawAreas;
        /// <summary>
        /// ̃XN[̗֊s\pX
        /// </summary>
        protected GraphicsPath graphicsPath;
        /// <summary>
        /// XN[ɕ`G
        /// </summary>
        protected Bitmap picture;
        /// <summary>
        /// eXN[
        /// </summary>
        protected IParentScreen parent;
        /// <summary>
        /// qXN[
        /// </summary>
        protected IChildScreen[] childs;
        /// <summary>
        /// XN[ɉf
        /// </summary>
        IProjectionData projectionData;
        
        public ChildScreen(string name)
            : base(name)
        {
            
        }

        /// <summary>
        /// `KvƂǉ
        /// </summary>
        /// <param name="addArea"></param>
        public void AddNeedtoDrawArea(RectangleF addArea)
        {
            // KvȂreturn;
            foreach (RectangleF area in needtoDrawAreas)
            {
                if (area.Contains(addArea))
                {
                    return;
                }
            }

            // V̂Ɋ܂܂ĂƂ
            Queue<RectangleF> tmpareas = new Queue<RectangleF>();
            foreach (RectangleF area in needtoDrawAreas)
            {
                if (!addArea.Contains(area))
                {
                    tmpareas.Enqueue(area);
                }
            }
            tmpareas.Enqueue(addArea);
            needtoDrawAreas = null; //ȂƂȂƂ
            needtoDrawAreas = new RectangleF[tmpareas.Count];

            // ߂Ȃ
            for (int n = 0; n < needtoDrawAreas.Length; n++)
            {
                needtoDrawAreas[n] = tmpareas.Dequeue();
            }
            tmpareas.Clear();
            tmpareas = null; //ȂƂȂƂ

            // ɂnĂI
            parent.AddNeedtoDrawArea(new RectangleF(
                new PointF(location.X + (addArea.Location.X * zoom.X), location.Y + (addArea.Location.Y * zoom.Y)),
                new SizeF(addArea.Width * zoom.X, addArea.Height * zoom.Y)
                )
            );

        }
        /// <summary>
        /// }EX̃Cxg󂯂XN[Ԃ
        /// </summary>
        /// <param name="mousePosition"></param>
        /// <returns></returns>
        public IScreen GetMouseContainScreen(PointF mousePosition)
        {
            // ̃XN[̔{A_gă}EXʒu\
            PointF tmpMousePosition = new PointF((mousePosition.X - this.location.X) / this.zoom.X, ( mousePosition.Y - this.location.Y) / this.zoom.Y);
            
            // ̃XN[ɓĂȂȂnullԂ
            if(!(new RectangleF(new PointF(0,0),this.size).Contains(tmpMousePosition)) || ((this.graphicsPath != null) && ( !(new Region(this.graphicsPath).IsVisible(tmpMousePosition)))))
            {
                return null;
            }

            IScreen mouseContainScreen = null;

            if(childs != null){
            for (int n = childs.Length - 1; n >=0; n--)
            {
                if ((mouseContainScreen = childs[n].GetMouseContainScreen(tmpMousePosition)) != null)
                {
                    return mouseContainScreen;
                }
            }
            }
            if (this.IsMouseEnable)
            {
                return this;
            }
            else
            {
                return null;
            }
        }
        /// <summary>
        /// `
        /// </summary>
        /// <param name="graphics"></param>
        /// <param name="drawAreas"></param>
        public void Draw(Graphics graphics, RectangleF[] drawAreas)
        {
            // ̃XN[`KvȂ炢낢return;@ȂȂ甲return;
            foreach (RectangleF area in drawAreas)
            {
                if (area.IntersectsWith(new RectangleF(this.location, new SizeF(this.size.Width * this.zoom.X, this.size.Height * this.zoom.Y))))
                {
                    // // pXƌ邩ǂׂׂȂxȂ肻ȋC邩Ȃ

                    // Oɉf̂ƈႤ̉fȂႢȂȂ`
                    if (this.needtoDrawAreas != null)
                    {
                        using (Graphics pGraphics = Graphics.FromImage(picture))
                        {
                            foreach (RectangleF needtoDrawArea in needtoDrawAreas)
                            {
                                pGraphics.SetClip(needtoDrawArea, CombineMode.Union);
                            }
                            pGraphics.FillRectangle(new SolidBrush(transeParencyKey), new Rectangle(new Point(0, 0), picture.Size));
                            pGraphics.DrawImage(projectionData.Picture, 0, 0);

                            if (childs != null)
                            {
                                foreach (IChildScreen child in childs)
                                {
                                    child.Draw(pGraphics, this.needtoDrawAreas);
                                }
                            }
                        }
                    }

                    // nꂽ̂ɕ`
                    using (ImageAttributes ia = new ImageAttributes())
                    {
                        ColorMatrix cm = new ColorMatrix();
                        cm.Matrix33 = opacity;
                        ia.SetColorMatrix(cm);

                        PointF[] tmpRect = new PointF[2];
                        tmpRect[0] = new PointF(this.location.X, this.location.Y);
                        tmpRect[1] = new PointF(this.size.Width * this.zoom.X, this.size.Height * this.zoom.Y);
                        graphics.DrawImage(picture, tmpRect, new RectangleF(new PointF(0, 0), this.size), GraphicsUnit.Pixel, ia);
                    }

                    needtoDrawAreas = null;
                }
            }
        }

        /// <summary>
        /// }EX̃{^ĂƂ̓
        /// </summary>
        public abstract void OnMousePress();
        /// <summary>
        /// }EX̃{^Ƃ̓
        /// </summary>
        /// <param name="e"></param>
        public abstract void OnMouseDown(MouseEventArgs e);
        /// <summary>
        /// }EX̃{^𗣂Ƃ̓
        /// </summary>
        /// <param name="e"></param>
        public abstract void OnMouseUp(MouseEventArgs e);
        /// <summary>
        /// }EX̃{^𓮂Ƃ̓
        /// </summary>
        /// <param name="e"></param>
        public abstract void OnMouseMove(MouseEventArgs e);
        /// <summary>
        /// }EXJ[\oƂ̓
        /// </summary>
        public abstract void OnMouseLeave();
        /// <summary>
        /// }EXJ[\Ƃ̓
        /// </summary>
        public abstract void OnMouseEnter();
        /// <summary>
        /// }EXJ[\莞Ԏ~܂ĂƂ̓
        /// </summary>
        public abstract void OnMouseHover();
        /// <summary>
        /// zC[ꂽƂ̓
        /// </summary>
        public abstract void OnMouseWheel();
    }
}
