using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace NoJava2Lib.GUI.OnForms
{
    class Screen :@GUIObject, IParentScreen
   { 
        protected GameForm form;
        public SizeF Size { get { return form.Size; } }
        RectangleF[] needtoDrawAreas;
        IChildScreen[] childs;
        static Color backgroundColor = Color.Black;

        public Screen(string name)
            : base(name)
        {
        }

        /// <summary>
        /// `
        /// </summary>
        /// <param name="isAll">S`XVƂ</param>
        public void Draw(bool isAll)
        {
            Bitmap picture = new Bitmap((int)this.Size.Width + 1, (int)this.Size.Height + 1);
            using (Graphics pGraphics = Graphics.FromImage(picture))
            {
                pGraphics.Clear(backgroundColor);
                foreach (RectangleF needroDrawArea in needtoDrawAreas)
                {
                    pGraphics.SetClip(needroDrawArea, System.Drawing.Drawing2D.CombineMode.Union);
                }
                foreach (IChildScreen child in childs)
                {
                    child.Draw(pGraphics, needtoDrawAreas);
                }
            }

            using (Graphics graphics = form.CreateGraphics())
            {
                if (!isAll)
                {
                    foreach (RectangleF needroDrawArea in needtoDrawAreas)
                    {
                        graphics.SetClip(needroDrawArea, System.Drawing.Drawing2D.CombineMode.Union);
                    }
                }
                graphics.DrawImage(picture, new Point(0, 0));
            }
            picture.Dispose();
            needtoDrawAreas = null;
        }

        /// <summary>
        /// }EX̃Cxg󂯂XN[Ԃ
        /// </summary>
        /// <param name="mousePosition"></param>
        /// <returns></returns>
        public IScreen GetMouseContainScreen(PointF mousePosition)
        {
            // XN[ɓĂȂȂnullԂ
            if (!(new RectangleF(new PointF(0, 0), this.Size).Contains(mousePosition)))
            {
                return null;
            }

            IScreen mouseContainScreen = null;

            if (childs != null)
            {
                for (int n = childs.Length - 1; n >= 0; n--)
                {
                    if ((mouseContainScreen = mouseContainScreen = childs[n].GetMouseContainScreen(mousePosition)) != null)
                    {
                        return mouseContainScreen;
                    }
                }
            }
                return this;
        }

        /// <summary>
        /// `Kv̈ǉ
        /// </summary>
        /// <param name="addArea"></param>
        public void AddNeedtoDrawArea(RectangleF addArea)
        {
            // KvȂreturn;
            foreach (RectangleF area in needtoDrawAreas)
            {
                if (area.Contains(addArea))
                {
                    return;
                }
            }

            // V̂Ɋ܂܂ĂƂ
            Queue<RectangleF> tmpareas = new Queue<RectangleF>();
            foreach (RectangleF area in needtoDrawAreas)
            {
                if (!addArea.Contains(area))
                {
                    tmpareas.Enqueue(area);
                }
            }
            tmpareas.Enqueue(addArea);
            needtoDrawAreas = null; //ȂƂȂƂ
            needtoDrawAreas = new RectangleF[tmpareas.Count];

            // ߂Ȃ
            for (int n = 0; n < needtoDrawAreas.Length; n++)
            {
                needtoDrawAreas[n] = tmpareas.Dequeue();
            }
            tmpareas.Clear();
            tmpareas = null; //ȂƂȂƂ
        }

        /// <summary>
        /// }EX̃{^ĂƂ̓
        /// </summary>
        public void OnMousePress(){}
        /// <summary>
        /// }EX̃{^Ƃ̓
        /// </summary>
        /// <param name="e"></param>
        public void OnMouseDown(MouseEventArgs e) { }
        /// <summary>
        /// }EX̃{^𗣂Ƃ̓
        /// </summary>
        /// <param name="e"></param>
        public void OnMouseUp(MouseEventArgs e) { }
        /// <summary>
        /// }EX̃{^𓮂Ƃ̓
        /// </summary>
        /// <param name="e"></param>
        public void OnMouseMove(MouseEventArgs e) { }
        /// <summary>
        /// }EXJ[\oƂ̓
        /// </summary>
        public void OnMouseLeave() { }
        /// <summary>
        /// }EXJ[\Ƃ̓
        /// </summary>
        public void OnMouseEnter() { }
        /// <summary>
        /// }EXJ[\莞Ԏ~܂ĂƂ̓
        /// </summary>
        public void OnMouseHover() { }
        /// <summary>
        /// zC[ꂽƂ̓
        /// </summary>
        public void OnMouseWheel() { }
    }
}
